# Developer Guide

This guide will help you to develop and contribute code to the project.

## TOC

* [Custom checks developer guide](checks/README.md)
  * [Python builtin modules](checks/builtins)
* [Agent IPC API](agent_api.md)
* [Agent development environment][dev-env]
* [How to build the Agent binaries](agent_build.md)
* [How to build the Agent packages][agent-omnibus]
* [Testing guide][testing]
* [Troubleshooting Memory Guide][memory]
* [Caveats][caveats]
* [Contributing][contributing]
* [Legal][legal]
* [Tools](tools.md) to troubleshoot a running Agent

## How to contribute

* [Sign the CLA][legal].
* Read the [contributing][contributing] guidelines.


[legal]: legal.md
[dev-env]: agent_dev_env.md
[testing]: agent_tests.md
[memory]: agent_memory.md
[caveats]: caveats.md
[contributing]: contributing.md
[agent-omnibus]: agent_omnibus.md
[tools]: tools.md
